Panda3D

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
PolylightEffect Class Reference

A PolylightEffect can be used on a node to define a LightGroup for that node. More...

`#include "polylightEffect.h"`

Inheritance diagram for PolylightEffect:

## Public Types
enum | ContribType { CT_proximal , CT_all }
typedef pvector< NodePath > | LightGroup

## Public Member Functions
| CPT (RenderAttrib) do_poly_light(const SceneSetup *scene
| CPT (RenderEffect) add_light(const NodePath &newlight) const
| CPT (RenderEffect) remove_light(const NodePath &newlight) const
| CPT (RenderEffect) set_contrib(ContribType c) const
| CPT (RenderEffect) set_effect_center(const LPoint3 &ec) const
| CPT (RenderEffect) set_weight(PN_stdfloat w) const
virtual void | cull_callback (CullTraverser *trav, CullTraverserData &data, CPT(TransformState) &node_transform, CPT(RenderState) &node_state) const
| If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time. More...
virtual TypeHandle | force_init_type ()
ContribType | get_contrib () const
| Returns CT_all or CT_proximal. More...
LPoint3 | get_effect_center () const
| Return the value of the _effect_center. More...
virtual TypeHandle | get_type () const
PN_stdfloat | get_weight () const
| Get the weight value. More...
virtual bool | has_cull_callback () const
| Should be overridden by derived classes to return true if cull_callback() has been defined. More...
bool | has_light (const NodePath &light) const
virtual void | output (std::ostream &out) const
Public Member Functions inherited from RenderEffect
| RenderEffect (const RenderEffect &copy)=delete
virtual | ~RenderEffect ()
| The destructor is responsible for removing the RenderEffect from the global set if it is there. More...
virtual void | adjust_transform (CPT(TransformState) &net_transform, CPT(TransformState) &node_transform, const PandaNode *node) const
int | compare_to (const RenderEffect &other) const
| Provides an arbitrary ordering among all unique RenderEffects, so we can store the essentially different ones in a big set and throw away the rest. More...
virtual | CPT (TransformState) prepare_flatten_transform(const TransformState *net_transform) const
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
virtual bool | has_adjust_transform () const
RenderEffect & | operator= (const RenderEffect &copy)=delete
virtual bool | safe_to_combine () const
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of RenderEffect by calling the xform() method, false otherwise. More...
virtual void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static | CPT (RenderEffect) make()
static | CPT (RenderEffect) make(PN_stdfloat weight
static | CPT (RenderEffect) make(PN_stdfloat weight
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from RenderEffect
static TypedWritable * | change_this (TypedWritable *old_ptr, BamReader *manager)
| Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired. More...
static TypeHandle | get_class_type ()
static int | get_num_effects ()
static void | init_type ()
static void | list_effects (std::ostream &out)
| Lists all of the RenderEffects in the cache to the output stream, one per line. More...
static bool | validate_effects ()
| Ensures that the cache is still stored in sorted order. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
const CullTraverserData const TransformState *node_transform | const
static ContribType | contrib
const CullTraverserData * | data
static ContribType const LPoint3 & | effect_center
static ContribType const LPoint3 const LightGroup & | lights
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A PolylightEffect can be used on a node to define a LightGroup for that node.

A LightGroup contains PolylightNodes which are essentially nodes that add color to the polygons of a model based on distance. PolylightNode is a cheap way to get lighting effects specially for night scenes

Definition at line 35 of file polylightEffect.h.

## Member Function Documentation

## ◆ cull_callback()

void PolylightEffect::cull_callback | ( | CullTraverser * | trav,
|  | CullTraverserData & | data,
|  | CPT(TransformState) & | node_transform,
|  | CPT(RenderState) & | node_state
| ) |  | const
| virtual

If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time.

This may include additional manipulation of render state or additional visible/invisible decisions, or any other arbitrary operation.

At the time this function is called, the current node's transform and state have not yet been applied to the net_transform and net_state. This callback may modify the node_transform and node_state to apply an effective change to the render state at this level.

Reimplemented from RenderEffect.

Definition at line 89 of file polylightEffect.cxx.

## ◆ get_contrib()

PolylightEffect::ContribType PolylightEffect::get_contrib | ( |  | ) | const
| inline

Returns CT_all or CT_proximal.

Definition at line 45 of file polylightEffect.I.

## ◆ get_effect_center()

LPoint3 PolylightEffect::get_effect_center | ( |  | ) | const
| inline

Return the value of the _effect_center.

Definition at line 53 of file polylightEffect.I.

## ◆ get_weight()

PN_stdfloat PolylightEffect::get_weight | ( |  | ) | const
| inline

Get the weight value.

Definition at line 37 of file polylightEffect.I.

## ◆ has_cull_callback()

bool PolylightEffect::has_cull_callback | ( |  | ) | const
| virtual

Should be overridden by derived classes to return true if cull_callback() has been defined.

Otherwise, returns false to indicate cull_callback() does not need to be called for this effect during the cull traversal.

Reimplemented from RenderEffect.

Definition at line 72 of file polylightEffect.cxx.

The documentation for this class was generated from the following files:

- panda/src/pgraph/polylightEffect.h
- panda/src/pgraph/polylightEffect.cxx
- panda/src/pgraph/polylightEffect.I